<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Processors/NameMapper.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Processors/NameMapper.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Processors/NameMapper.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno"> 8</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Processor, Parameter</span>
<a id="line10"></a><span class="lineno">10</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line11"></a><span class="lineno">11</span>
<a id="line12"></a><span class="lineno">12</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Processors/NameMapper/NameMapper.html">NameMapper</a>(Processor, ASG.Visitor):</span>
<a id="line13"></a><span class="lineno">13</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Abstract base class for name mapping.&quot;&quot;&quot;</span></span>
<a id="line14"></a><span class="lineno">14</span>
<a id="line15"></a><span class="lineno">15</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/NameMapper/NameMapper.html#visit_scope">visit_scope</a>(self, node):</span>
<a id="line16"></a><span class="lineno">16</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Recursively visits declarations under this scope.&quot;&quot;&quot;</span></span>
<a id="line17"></a><span class="lineno">17</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">        self.visit_declaration(node)</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> node.declarations:</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">            d.accept(self)</span>
<a id="line21"></a><span class="lineno">21</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/NameMapper/NameMapper.html#visit_group">visit_group</a>(self, node):</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Recursively visits declarations under this group.&quot;&quot;&quot;</span></span>
<a id="line24"></a><span class="lineno">24</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">        self.visit_declaration(node)</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> node.declarations:</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">            d.accept(self)</span>
<a id="line28"></a><span class="lineno">28</span>
<a id="line29"></a><span class="lineno">29</span>
<a id="line30"></a><span class="lineno">30</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Processors/NameMapper/NamePrefixer.html">NamePrefixer</a>(NameMapper):</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">    <span class="py-string">&quot;&quot;&quot;This class adds a prefix to all declaration and type names.&quot;&quot;&quot;</span></span>
<a id="line32"></a><span class="lineno">32</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">    prefix = Parameter([], <span class="py-string">'the prefix which to prepend to all declared types'</span>)</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">    type = Parameter(<span class="py-string">'Language'</span>, <span class="py-string">'type to use for the new toplevel modules'</span>)</span>
<a id="line35"></a><span class="lineno">35</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/NameMapper/NamePrefixer.html#process">process</a>(self, ir, **kwds):</span>
<a id="line37"></a><span class="lineno">37</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">        self.ir = self.merge_input(ir)</span>
<a id="line40"></a><span class="lineno">40</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.prefix:</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">            <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line43"></a><span class="lineno">43</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">        <span class="py-keyword">for</span> decl <span class="py-keyword">in</span> self.ir.asg.declarations:</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">            decl.accept(self)</span>
<a id="line46"></a><span class="lineno">46</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">        <span class="py-comment"># Now we need to put the declarations in actual nested MetaModules</span></span>
<a id="line48"></a><span class="lineno">48</span><span class="line">        <span class="py-keyword">for</span> index <span class="py-keyword">in</span> range(len(self.prefix), 0, -1):</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">            module = ASG.MetaModule(self.type, self.prefix[:index])</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">            module.declarations.extend(self.ir.asg.declarations)</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">            self.ir.asg.types[module.name] = ASG.DeclaredTypeId(<span class="py-string">''</span>,</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">                                                                module.name,</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">                                                                module)</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">            self.ir.asg.declarations[:] = [module]</span>
<a id="line55"></a><span class="lineno">55</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">        <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line57"></a><span class="lineno">57</span>
<a id="line58"></a><span class="lineno">58</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Processors/NameMapper/NamePrefixer.html#visit_declaration">visit_declaration</a>(self, decl):</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Changes the name of this declaration and its associated type&quot;&quot;&quot;</span></span>
<a id="line60"></a><span class="lineno">60</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">        <span class="py-comment"># Change the name of the decl</span></span>
<a id="line62"></a><span class="lineno">62</span><span class="line">        name = decl.name</span>
<a id="line63"></a><span class="lineno">63</span><span class="line">        new_name = tuple(self.prefix + list(name))</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">        decl.name = new_name</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">        <span class="py-comment"># Change the name of the associated type</span></span>
<a id="line66"></a><span class="lineno">66</span><span class="line">        <span class="py-keyword">try</span>:</span>
<a id="line67"></a><span class="lineno">67</span><span class="line">            type = self.ir.asg.types[name]</span>
<a id="line68"></a><span class="lineno">68</span><span class="line">            <span class="py-keyword">del</span> self.ir.asg.types[name]</span>
<a id="line69"></a><span class="lineno">69</span><span class="line">            type.name = new_name</span>
<a id="line70"></a><span class="lineno">70</span><span class="line">            self.ir.asg.types[new_name] = type</span>
<a id="line71"></a><span class="lineno">71</span><span class="line">        <span class="py-keyword">except</span> KeyError, msg:</span>
<a id="line72"></a><span class="lineno">72</span><span class="line">            <span class="py-keyword">if</span> self.verbose: <span class="py-keyword">print</span> <span class="py-string">&quot;Warning: Unable to map name of type:&quot;</span>,msg</span>
<a id="line73"></a><span class="lineno">73</span>
<a id="line74"></a><span class="lineno">74</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:13 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
